// Written by Philipp Erler
// Last change 2012-03-20
// This code is not meant to be sold.
// You may use this code or parts of it for your own software.
// Please respect my work. Mentioning my name in your code would be nice.

#include <math.h>

#include "OpenALSurroundMachine.h"

#define PI						3.1415926536
#define FREQ					48000
	
short SinusForBuffer(int sample, int channel, int frequency);		// 440Hz for all channels

//devsupport@creativelabs.com
//http://opensource.creative.com/mailman/listinfo/openal

int main()
{
	OpenALSurroundMachine soundMachine(FREQ, (int)(FREQ * 0.5));				// 0.5sec
	// fill buffers with (sinus) data
	soundMachine.CreateBuffer(SinusForBuffer);
	soundMachine.PlaySource();

	return 0;
}

short SinusForBuffer(int sample, int channel, int frequency)
{
	// 3D surround works only with mono sound buffers
	// so there is only 1 channel used
	double phase = (double)sample * (2.0 * PI) * 440.0 / (double)frequency;
	short value = (short)(0.5f*SHRT_MAX*sin(phase));

	return value;
}